﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO.Ports;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace Modul_B_WPF
{
		/// <summary>
		/// Interaktionslogik für MainWindow.xaml
		/// </summary>
		public partial class MainWindow : Window
		{
				private SerialPort serialPort = new SerialPort();
				private DispatcherTimer timer;
				private bool[] modus = new bool[16];
				private bool[] digitalOut = new bool[16];
				private bool[] digitalIn = new bool[16];
				char[] cOut = new char[36];

				public MainWindow()
				{
						InitializeComponent();
						timer = new DispatcherTimer();
						timer.Interval = TimeSpan.FromMilliseconds(100);
						timer.Tick += Timer_Tick;
				}

				private void Timer_Tick(object sender, EventArgs e)
				{
						int count = serialPort.BytesToRead;
						char[] cIn = new char[count];
						if (serialPort.IsOpen)
						{
								serialPort.Write(cOut, 0, 33);
								if (count > 0)
								{
										serialPort.Read(cIn, 0, count);
								}
								try
								{
										for (int i = 0; i < 16; i++)
												if (cIn[i] == 'H')
														digitalIn[i] = true;
												else
														digitalIn[i] = false;
								}
								catch
								{
								}
						}
						Auswerten();
				}

				private void WindowModulB_Loaded(object sender, RoutedEventArgs e)
				{
						buttonVerbinden.IsEnabled = false;
						buttonTrennen.IsEnabled = false;
						SetControls(false);
						string[] ports = SerialPort.GetPortNames();
						Array.Sort(ports);
						if (ports.Length > 0)
						{
								foreach (string Port in ports)
										comboBoxPort.Items.Add(Port);
								comboBoxPort.SelectedIndex = 0;
								buttonVerbinden.IsEnabled = true;
						}
						for (int i = 0; i < 8; i++)
						{
								digitalOut[i] = false;
								modus[i] = false;
						}
				}

				private void SetControls(bool status)
				{
						buttonGpio0.IsEnabled = status;
						buttonGpio1.IsEnabled = status;
						buttonGpio2.IsEnabled = status;
						buttonGpio3.IsEnabled = status;
						buttonGpio4.IsEnabled = status;
						buttonGpio5.IsEnabled = status;
						buttonGpio6.IsEnabled = status;
						buttonGpio7.IsEnabled = status;
						buttonGpio8.IsEnabled = status;
						buttonGpio9.IsEnabled = status;
						buttonGpio10.IsEnabled = status;
						buttonGpio11.IsEnabled = status;
						buttonGpio12.IsEnabled = status;
						buttonGpio12.IsEnabled = status;
						buttonGpio14.IsEnabled = status;
						buttonGpio15.IsEnabled = status;
						checkBoxGpio0.IsEnabled = status;
						checkBoxGpio1.IsEnabled = status;
						checkBoxGpio2.IsEnabled = status;
						checkBoxGpio3.IsEnabled = status;
						checkBoxGpio4.IsEnabled = status;
						checkBoxGpio5.IsEnabled = status;
						checkBoxGpio6.IsEnabled = status;
						checkBoxGpio7.IsEnabled = status;
						checkBoxGpio8.IsEnabled = status;
						checkBoxGpio9.IsEnabled = status;
						checkBoxGpio10.IsEnabled = status;
						checkBoxGpio11.IsEnabled = status;
						checkBoxGpio12.IsEnabled = status;
						checkBoxGpio13.IsEnabled = status;
						checkBoxGpio14.IsEnabled = status;
						checkBoxGpio15.IsEnabled = status;
				}

				private void WindowModulB_Closing(object sender, System.ComponentModel.CancelEventArgs e)
				{
						if (serialPort.IsOpen)
						{
								Auswerten();
								serialPort.Write("AAAAAAAAAAAAAAAA-LLLLLLLLLLLLLLLL");
								serialPort.Close();
						}
				}

				private void ButtonVerbinden_Click(object sender, RoutedEventArgs e)
				{
						try
						{
								buttonVerbinden.IsEnabled = false;
								buttonTrennen.IsEnabled = true;
								SetControls(true);
								serialPort.PortName = comboBoxPort.Text;
								serialPort.BaudRate = 9600;
								serialPort.DtrEnable = false;
								serialPort.RtsEnable = true;
								serialPort.Open();
								timer.Start();
						}
						catch
						{
								buttonVerbinden.IsEnabled = true;
								buttonTrennen.IsEnabled = false;
								SetControls(false);
								MessageBox.Show("Die Schnittstelle konnte nicht geöffnet werden!");
						}
				}

				private void ButtonTrennen_Click(object sender, RoutedEventArgs e)
				{
						buttonVerbinden.IsEnabled = true;
						buttonTrennen.IsEnabled = false;
						SetControls(false);
						for (int i = 0; i < 16; i++)
						{
								modus[i] = false;
								digitalOut[i] = false;
						}
						Auswerten();
						timer.Stop();
						serialPort.Write("AAAAAAAAAAAAAAAA-LLLLLLLLLLLLLLLL");
						serialPort.Close();
				}

				private void ButtonGpio0_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[0] = !digitalOut[0];
				}

				private void ButtonGpio1_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[1] = !digitalOut[1];
				}

				private void ButtonGpio2_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[2] = !digitalOut[2];
				}

				private void ButtonGpio3_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[3] = !digitalOut[3];
				}

				private void ButtonGpio4_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[4] = !digitalOut[4];
				}

				private void ButtonGpio5_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[5] = !digitalOut[5];
				}

				private void ButtonGpio6_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[6] = !digitalOut[6];
				}

				private void ButtonGpio7_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[7] = !digitalOut[7];
				}

				private void ButtonGpio8_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[8] = !digitalOut[8];
				}

				private void ButtonGpio9_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[9] = !digitalOut[9];
				}

				private void ButtonGpio10_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[10] = !digitalOut[10];
				}

				private void ButtonGpio11_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[11] = !digitalOut[11];
				}

				private void ButtonGpio12_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[12] = !digitalOut[12];
				}

				private void ButtonGpio13_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[13] = !digitalOut[13];
				}

				private void ButtonGpio14_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[14] = !digitalOut[14];
				}

				private void ButtonGpio15_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[15] = !digitalOut[15];
				}

				private void Auswerten()
				{
						if (checkBoxGpio0.IsChecked == true)
						{
								modus[0] = true;
								textBoxGpio0.Background = Brushes.Orange;
								buttonGpio0.IsEnabled = false;
								if (digitalIn[0])
										textBoxGpio0.Text = "H";
								else
										textBoxGpio0.Text = "L";
						}
						else
						{
								modus[0] = false;
								textBoxGpio0.Background = Brushes.LightSteelBlue;
								buttonGpio0.IsEnabled = true;
								if (digitalOut[0])
										textBoxGpio0.Text = "H";
								else
										textBoxGpio0.Text = "L";
						}

						if (checkBoxGpio1.IsChecked == true)
						{
								modus[1] = true;
								textBoxGpio1.Background = Brushes.Orange;
								buttonGpio1.IsEnabled = false;
								if (digitalIn[1])
										textBoxGpio1.Text = "H";
								else
										textBoxGpio1.Text = "L";
						}
						else
						{
								modus[1] = false;
								textBoxGpio1.Background = Brushes.LightSteelBlue;
								buttonGpio1.IsEnabled = true;
								if (digitalOut[1])
										textBoxGpio1.Text = "H";
								else
										textBoxGpio1.Text = "L";
						}

						if (checkBoxGpio2.IsChecked == true)
						{
								modus[2] = true;
								textBoxGpio2.Background = Brushes.Orange;
								buttonGpio2.IsEnabled = false;
								if (digitalIn[2])
										textBoxGpio2.Text = "H";
								else
										textBoxGpio2.Text = "L";
						}
						else
						{
								modus[2] = false;
								textBoxGpio2.Background = Brushes.LightSteelBlue;
								buttonGpio2.IsEnabled = true;
								if (digitalOut[2])
										textBoxGpio2.Text = "H";
								else
										textBoxGpio2.Text = "L";
						}

						if (checkBoxGpio3.IsChecked == true)
						{
								modus[3] = true;
								textBoxGpio3.Background = Brushes.Orange;
								buttonGpio3.IsEnabled = false;
								if (digitalIn[3])
										textBoxGpio3.Text = "H";
								else
										textBoxGpio3.Text = "L";
						}
						else
						{
								modus[3] = false;
								textBoxGpio3.Background = Brushes.LightSteelBlue;
								buttonGpio3.IsEnabled = true;
								if (digitalOut[3])
										textBoxGpio3.Text = "H";
								else
										textBoxGpio3.Text = "L";
						}

						if (checkBoxGpio4.IsChecked == true)
						{
								modus[4] = true;
								textBoxGpio4.Background = Brushes.Orange;
								buttonGpio4.IsEnabled = false;
								if (digitalIn[4])
										textBoxGpio4.Text = "H";
								else
										textBoxGpio4.Text = "L";
						}
						else
						{
								modus[4] = false;
								textBoxGpio4.Background = Brushes.LightSteelBlue;
								buttonGpio4.IsEnabled = true;
								if (digitalOut[4])
										textBoxGpio4.Text = "H";
								else
										textBoxGpio4.Text = "L";
						}

						if (checkBoxGpio5.IsChecked == true)
						{
								modus[5] = true;
								textBoxGpio5.Background = Brushes.Orange;
								buttonGpio5.IsEnabled = false;
								if (digitalIn[5])
										textBoxGpio5.Text = "H";
								else
										textBoxGpio5.Text = "L";
						}
						else
						{
								modus[5] = false;
								textBoxGpio5.Background = Brushes.LightSteelBlue;
								buttonGpio5.IsEnabled = true;
								if (digitalOut[5])
										textBoxGpio5.Text = "H";
								else
										textBoxGpio5.Text = "L";
						}

						if (checkBoxGpio6.IsChecked == true)
						{
								modus[6] = true;
								textBoxGpio6.Background = Brushes.Orange;
								buttonGpio6.IsEnabled = false;
								if (digitalIn[6])
										textBoxGpio6.Text = "H";
								else
										textBoxGpio6.Text = "L";
						}
						else
						{
								modus[6] = false;
								textBoxGpio6.Background = Brushes.LightSteelBlue;
								buttonGpio6.IsEnabled = true;
								if (digitalOut[6])
										textBoxGpio6.Text = "H";
								else
										textBoxGpio6.Text = "L";
						}

						if (checkBoxGpio7.IsChecked == true)
						{
								modus[7] = true;
								textBoxGpio7.Background = Brushes.Orange;
								buttonGpio7.IsEnabled = false;
								if (digitalIn[7])
										textBoxGpio7.Text = "H";
								else
										textBoxGpio7.Text = "L";
						}
						else
						{
								modus[7] = false;
								textBoxGpio7.Background = Brushes.LightSteelBlue;
								buttonGpio7.IsEnabled = true;
								if (digitalOut[7])
										textBoxGpio7.Text = "H";
								else
										textBoxGpio7.Text = "L";
						}

						if (checkBoxGpio8.IsChecked == true)
						{
								modus[8] = true;
								textBoxGpio8.Background = Brushes.Orange;
								buttonGpio8.IsEnabled = false;
								if (digitalIn[8])
										textBoxGpio8.Text = "H";
								else
										textBoxGpio8.Text = "L";
						}
						else
						{
								modus[8] = false;
								textBoxGpio8.Background = Brushes.LightSteelBlue;
								buttonGpio8.IsEnabled = true;
								if (digitalOut[8])
										textBoxGpio8.Text = "H";
								else
										textBoxGpio8.Text = "L";
						}

						if (checkBoxGpio9.IsChecked == true)
						{
								modus[9] = true;
								textBoxGpio9.Background = Brushes.Orange;
								buttonGpio9.IsEnabled = false;
								if (digitalIn[9])
										textBoxGpio9.Text = "H";
								else
										textBoxGpio9.Text = "L";
						}
						else
						{
								modus[9] = false;
								textBoxGpio9.Background = Brushes.LightSteelBlue;
								buttonGpio9.IsEnabled = true;
								if (digitalOut[9])
										textBoxGpio9.Text = "H";
								else
										textBoxGpio9.Text = "L";
						}

						if (checkBoxGpio10.IsChecked == true)
						{
								modus[10] = true;
								textBoxGpio10.Background = Brushes.Orange;
								buttonGpio10.IsEnabled = false;
								if (digitalIn[10])
										textBoxGpio10.Text = "H";
								else
										textBoxGpio10.Text = "L";
						}
						else
						{
								modus[10] = false;
								textBoxGpio10.Background = Brushes.LightSteelBlue;
								buttonGpio10.IsEnabled = true;
								if (digitalOut[10])
										textBoxGpio10.Text = "H";
								else
										textBoxGpio10.Text = "L";
						}

						if (checkBoxGpio11.IsChecked == true)
						{
								modus[11] = true;
								textBoxGpio11.Background = Brushes.Orange;
								buttonGpio11.IsEnabled = false;
								if (digitalIn[11])
										textBoxGpio11.Text = "H";
								else
										textBoxGpio11.Text = "L";
						}
						else
						{
								modus[11] = false;
								textBoxGpio11.Background = Brushes.LightSteelBlue;
								buttonGpio11.IsEnabled = true;
								if (digitalOut[11])
										textBoxGpio11.Text = "H";
								else
										textBoxGpio11.Text = "L";
						}

						if (checkBoxGpio12.IsChecked == true)
						{
								modus[12] = true;
								textBoxGpio12.Background = Brushes.Orange;
								buttonGpio12.IsEnabled = false;
								if (digitalIn[12])
										textBoxGpio12.Text = "H";
								else
										textBoxGpio12.Text = "L";
						}
						else
						{
								modus[12] = false;
								textBoxGpio12.Background = Brushes.LightSteelBlue;
								buttonGpio12.IsEnabled = true;
								if (digitalOut[12])
										textBoxGpio12.Text = "H";
								else
										textBoxGpio12.Text = "L";
						}

						if (checkBoxGpio13.IsChecked == true)
						{
								modus[13] = true;
								textBoxGpio13.Background = Brushes.Orange;
								buttonGpio13.IsEnabled = false;
								if (digitalIn[13])
										textBoxGpio13.Text = "H";
								else
										textBoxGpio13.Text = "L";
						}
						else
						{
								modus[13] = false;
								textBoxGpio13.Background = Brushes.LightSteelBlue;
								buttonGpio13.IsEnabled = true;
								if (digitalOut[13])
										textBoxGpio13.Text = "H";
								else
										textBoxGpio13.Text = "L";
						}

						if (checkBoxGpio14.IsChecked == true)
						{
								modus[14] = true;
								textBoxGpio14.Background = Brushes.Orange;
								buttonGpio14.IsEnabled = false;
								if (digitalIn[14])
										textBoxGpio14.Text = "H";
								else
										textBoxGpio14.Text = "L";
						}
						else
						{
								modus[14] = false;
								textBoxGpio14.Background = Brushes.LightSteelBlue;
								buttonGpio14.IsEnabled = true;
								if (digitalOut[14])
										textBoxGpio14.Text = "H";
								else
										textBoxGpio14.Text = "L";
						}

						if (checkBoxGpio15.IsChecked == true)
						{
								modus[15] = true;
								textBoxGpio15.Background = Brushes.Orange;
								buttonGpio15.IsEnabled = false;
								if (digitalIn[15])
										textBoxGpio15.Text = "H";
								else
										textBoxGpio15.Text = "L";
						}
						else
						{
								modus[15] = false;
								textBoxGpio15.Background = Brushes.LightSteelBlue;
								buttonGpio15.IsEnabled = true;
								if (digitalOut[15])
										textBoxGpio15.Text = "H";
								else
										textBoxGpio15.Text = "L";
						}

						for (int i = 0; i < 16; i++)
						{
								if (modus[i])
										cOut[i] = 'E';
								else
										cOut[i] = 'A';
						}
						cOut[16] = '-';
						for (int i = 0; i < 16; i++)
						{
								if (digitalOut[i])
										cOut[17 + i] = 'H';
								else
										cOut[17 + i] = 'L';
						}
				}
		}
}
